--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
Anticipation.lua - A module for tracking Anticipation buff stacks
$Date: 2015-01-30 05:30:19 +0000 (Fri, 30 Jan 2015) $
$Revision: 367 $
Project Version: r367
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2012 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "ROGUE" then return end

local UnitBuff = UnitBuff

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Anticipation"
local mod = cpr:NewModule(modName)
local buff = GetSpellInfo(114015)

function mod:OnInitialize()
	self.abbrev = "A"
	self.MAX_POINTS = 5
	self.displayName = buff
	self.events = { "UNIT_AURA" }
end

local oldCount = 0
function mod:UNIT_AURA(_, unit)
	if unit ~= "player" then return end
	
	local _, _, _, count = UnitBuff("player", buff)
	if count and oldCount ~= count then
		--should prevent spamming issues when UNIT_AURA fires and
		--the aura we care about hasn't changed
		oldCount = count
		
		if self.graphics then
			local r, g, b = cpr:GetColorByPoints(modName, count)
			for i = count, 1, -1 do
				self.graphics.points[i].icon:SetVertexColor(r, g, b)
				self.graphics.points[i]:Show()
			end
			for j = self.MAX_POINTS, count+1, -1 do
				self.graphics.points[j]:Hide()
			end
		end
		if self.text then self.text:SetNumPoints(count) end
		
		cpr:DoFlash(modName, count)
	else
		if self.graphics then
			for i = 1, self.MAX_POINTS do
				self.graphics.points[i]:Hide()
			end
		end
		if self.text then self.text:SetNumPoints("") end
		
		oldCount = 0
	end
end
